﻿using System.Collections.Generic;
using Syncfusion.DocIO.DLS;
using Syncfusion.DocIO;

namespace ConsoleApplication65
{
    class Program
    {
        static void Main(string[] args)
        {
            // Creating a new document.
            WordDocument document = new WordDocument();
            //Add new section into Word document
            document.AddSection();
            //Get the custom class list which has array of string
            List<MyCustomClass> tempMyCustomClasse = GetMyCustomClass();
            //Get the maximum number of columns going to be added
            int maxRowCount = GetMaxRowCount(tempMyCustomClasse);
            //Get the maximum number of cells
            int maxCellCount = tempMyCustomClasse.Count;
            //Add the table into the Word document
            WTable table = document.LastSection.AddTable() as WTable;
            table.ResetCells(maxRowCount, maxCellCount);
            int columnIndex = 0;
            //Merge the array content into the table
            foreach (MyCustomClass item in tempMyCustomClasse)
            {
                MergeArrayInTable(table, item.Werte, columnIndex);
                columnIndex++;
            }

            //Saves the document in the given name and format

            document.Save("result.docx", FormatType.Docx);

            //Releases the resources occupied by WordDocument instance

            document.Close();
        }
        private static void MergeArrayInTable(WTable table, string[] array, int columnIndex)
        {
            for (int i = 0; i < array.Length; i++)
            {
                table[i, columnIndex].AddParagraph().AppendText(array[i]);
            }
        }
        private static List<MyCustomClass> GetMyCustomClass()
        {
            List<MyCustomClass> tempMyCustomClasse = new List<MyCustomClass>();
            MyCustomClass class1 = new MyCustomClass();
            class1.Werte = new string[5];
            class1.Werte[0] = "one";
            class1.Werte[1] = "two";
            class1.Werte[2] = "three";
            class1.Werte[3] = "four";
            class1.Werte[4] = "five";
            tempMyCustomClasse.Add(class1);

            MyCustomClass class2 = new MyCustomClass();
            class2.Werte = new string[6];
            class2.Werte[0] = "one";
            class2.Werte[1] = "two";
            class2.Werte[2] = "three";
            class2.Werte[3] = "four";
            class2.Werte[4] = "five";
            class2.Werte[5] = "Six";
            tempMyCustomClasse.Add(class2);

            MyCustomClass class3 = new MyCustomClass();
            class3.Werte = new string[4];
            class3.Werte[0] = "one";
            class3.Werte[1] = "two";
            class3.Werte[2] = "three";
            class3.Werte[3] = "four";
            tempMyCustomClasse.Add(class3);

            return tempMyCustomClasse;
        }
        private static int GetMaxRowCount(List<MyCustomClass> tempMyCustomClasse)
        {
            int maxRowCount = 0;
            foreach (MyCustomClass item in tempMyCustomClasse)
            {
                if (item.Werte != null && item.Werte.Length > maxRowCount)
                    maxRowCount = item.Werte.Length;
            }
            return maxRowCount;
        }
    }
    class MyCustomClass

    {
        public string[] Werte { get; set; }

        public MyCustomClass()

        {
        }
    }
}
